import Graphics.Rendering.Diagrams

vert n = hsep 10 . replicate n . straight . pathFromVertices $ [(0,0), (0,10*(fromIntegral n-1))]
horiz = rotate (1/4) . vert

nums n = vdistribA 10 vcenter hcenter (map (text 5 . show) (reverse $ take n [1..]))
fred = translate (-2) 2 $ fc blue $ circle 2
school = translate (2) (-2) $ fc red $ circle 2

grid n = unionA right top
         [
           unionA left bottom
           [
             vert n ## horiz n
           , fred
           ]
         , school
         ]

manhattan n = nums n <>
             (vspace 5 //
             (vsepA 3 hcenter
              [ grid n
              , hdistrib 10 hcenter (map (text 5 . (:[])) (take n ['A'..]))
              ]
             ))

main = renderAs PS "grid.ps" (Width 100) (manhattan 5)